using GraphicsManager.Interfaces;

namespace GraphicsManager.Objects.Core;

public class ControlList
{
    private List<IRenderObject> _internal = new();

    public IRenderObject this[int Index] => _internal[Index];

    public IEnumerable<IRenderObject> Where(Func<IRenderObject, bool> func) => _internal.Where(func);

    public int Length => _internal.Count;

    public void Remove(IRenderObject item)
    {
        _internal.Remove(item);
        item.Clean();
    }
    
    public void Add(IRenderObject item)
    {
        _internal.Add(item);
    }
    
    public void Clear()
    {
        foreach (IRenderObject con in _internal)
        {
            con.Clean();
        }
        _internal.Clear();
    }
}